// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNSceneEventsParser.hpp"

using namespace Dawn;

std::vector<std::string> VNSceneEventsParser::getRequiredAttributes() {
  return { };
}

std::map<std::string, std::string> VNSceneEventsParser::getOptionalAttributes() {
  return { };
}

int32_t VNSceneEventsParser::onParse(
  Xml *node,
  std::map<std::string, std::string> values,
  struct VNSceneEvent *out,
  std::string *error
) {
  int32_t ret;

  auto itChildren = node->children.begin();
  while(itChildren != node->children.end()) {
    Xml *child = *itChildren;

    // Parse event(s)
    if(child->node == "position") {
      struct VNPosition position;
      ret = (VNPositionParser()).parse(child, &position, error);
      if(ret != 0) return ret;
      out->position = position;
    }

    itChildren++;
  }

  return 0;
}